%define DATE 20050423
%define gcc_version 4.1.1
%define gcc_release 2tr
%define multilib_64_archs sparc64 ppc64 s390x x86_64
%ifarch s390x
%define multilib_32_arch s390
%endif
%ifarch sparc64
%define multilib_32_arch sparc
%endif
%ifarch ppc64
%define multilib_32_arch ppc
%endif
%ifarch x86_64
%define multilib_32_arch i386
%endif

%ifarch sparc ppc
echo we probably do not support building on %{_arch} 
exit 99
%endif

Summary: GNU Compiler Collection
Name: gcc4
Version: %{gcc_version}
Release: %{gcc_release}
License: GPL
Group: Trustix Official
Source0: gcc-%{version}.tar.bz2
Source1: gcc-3.2.2-fixinc.sh.trustix

#Not available for GCC-4.0.0
#Source2: gcc-protector-3.4-2.tar.gz
Source3: libgcc_post_upgrade.c
#Source4: gcc-3.3.3-ssp-3.3-7-fixup.patch
BuildRoot: /var/tmp/%{name}-%{version}-root
Obsoletes: egcs

Requires: binutils >= 2.15
Requires: gcc4-cpp = %{version}
Requires: gcc-runtime

Prereq: htmlinfo
BuildRequires: texinfo


Patch0: gcc-4.1-version.patch
# Not applied
#Patch1: gcc-3.4-%{DATE}.patch.bz2
Patch2: gcc34-ppc64-m32-m64-multilib-only.patch
# Not applied
# Patch3: gcc-3.4-ice-16026.patch
# Bug Fix patches
Patch4: gcc4-pr20249.patch
Patch6: gcc4-pr20490.patch
Patch13: gcc-4.0-libstdc++-mt-alloc.patch
Patch15: gcc4-ice-hack.patch
Patch16: gcc-4.1.1-CVE-2006-3619.patch

%define _gnu %{nil}
%ifarch sparc
%define gcc_target_platform sparc64-%{_vendor}-%{_target_os}
%endif
%ifarch ppc
%define gcc_target_platform ppc64-%{_vendor}-%{_target_os}
%endif
%ifnarch sparc ppc
%define gcc_target_platform %{_target_platform}
%endif

%description
The gcc package contains the GNU Compiler Collection: cc and gcc. You'll need
this package in order to compile C code.

#%package runtime
#Summary: C runtime environment
#Group: Trustix Official

#%description runtime
#This is the C runtime part of the GNU Compiler Collection.  There may be
#a few C programs linked against this library.

#%package c++-runtime
#Summary: C++ runtime environment
#Group: Trustix Official
#Provides: gcc-c++

#%description c++-runtime
#This is the C++ runtime part of the GNU Compiler Collection.  You'll need
#this package to run C++ programs linked against libstdc++.

%package c++-devel
Summary: C++ development environment
Group: Trustix Official
PreReq: gcc4

%description c++-devel
This is the C++ development part of the GNU Compiler Collection.  You'll need
this package to compile C++ programs.

%package cpp
Summary: C Pre Processor
Group: Trustix Official

%description cpp
This is the C Pre Processor.  Needed to compile.

%package libmudflap
Summary: GCC mudflap shared support library
Group: Trustix Official
Obsoletes: gcc-libmudflap

%description libmudflap
This package contains GCC shared support library which is needed
for mudflap support.

%package libmudflap-devel
Summary: GCC mudflap support
Group: Trustix Official
Requires: gcc4 = %{version}-%{release}
Obsoletes: gcc-libmudflap-devel

%description libmudflap-devel
This package contains headers and static libraries for building
mudflap-instrumented programs.

To instrument a non-threaded program, add -fmudflap
option to GCC and when linking add -lmudflap, for threaded programs
also add -fmudflapth and -lmudflapth.

%package gcj
Summary: The GNU Compiler for Java
Group: Trustix Official

%description gcj
The GNU Compiler for Java

%package gcj-devel
Summary: The GNU Compiler for Java.  Development files
Group: Trustix Official

%description gcj-devel
The GNU Compiler for Java.  Development files

%package objc
Summary: The GNU Compiler for Objective C.
Group: Trustix Official

%description objc
The GNU Compiler for Objective C.

%package objc-devel
Summary: The GNU Compiler for Objective C.  Development files
Group: Trustix Official

%description objc-devel
The GNU Compiler for Objective C.  Development files

%prep
%setup -q -n gcc-%{version}
#%setup -q
%patch0 -p1
%patch2 -p0 -b .ppc64-m32-m64-multilib-only
%patch4 -p0
%patch6 -p0
%patch13 -p0
%patch15 -p0
%patch16 -p2

# Misdesign in libstdc++
cp -a libstdc++-v3/config/cpu/i{4,3}86/atomicity.h

./contrib/gcc_update --touch

%build
set -xv

#
# Not available for GCC-4.0.0 - Removing stack_protector for now
#
# enable ibm stack protector
#tar xzvf %{SOURCE2}
#patch -p0 < protector.dif
#%{?enable_stack_protector_by_default: patch -p0 < protectonly.dif }

rm -fr obj-%{gcc_target_platform}
mkdir obj-%{gcc_target_platform}
cd obj-%{gcc_target_platform}

CC=gcc

OPT_FLAGS=`echo $RPM_OPT_FLAGS|sed -e 's/-fno-rtti//g' -e 's/-fno-exceptions//g' -e 's/-mtune=pentium//'`
%ifarch sparc sparc64
OPT_FLAGS=`echo $OPT_FLAGS|sed -e 's/-m64//g' -e 's/-m32//g' -e 's/-mcpu=ultrasparc/-mtune=ultrasparc/g'`
%endif
%ifarch ppc ppc64
OPT_FLAGS=`echo $OPT_FLAGS|sed -e 's/-m64//g' -e 's/-m32//g'`
%endif
%ifarch sparc64
cat > gcc64 <<"EOF"
#!/bin/sh
exec /usr/bin/gcc -m64 "$@"
EOF
chmod +x gcc64
CC=`pwd`/gcc64
%endif
%ifarch ppc64
if gcc -m64 -xc -S /dev/null -o - > /dev/null 2>&1; then
  cat > gcc64 <<"EOF"
#!/bin/sh
exec /usr/bin/gcc -m64 "$@"
EOF
  chmod +x gcc64
  CC=`pwd`/gcc64
fi
%endif
CC="$CC" CFLAGS="$OPT_FLAGS" CXXFLAGS="$OPT_FLAGS" XCFLAGS="$OPT_FLAGS" TCFLAGS="$OPT_FLAGS" \
        GCJFLAGS="$OPT_FLAGS" \
        ../configure --prefix=%{_prefix} --libexecdir=%{_prefix}/lib \
        --mandir=%{_mandir} --infodir=%{_infodir} \
        --enable-shared --enable-threads=posix --disable-checking \
	--disable-libunwind-exceptions \
        --with-system-zlib --enable-__cxa_atexit \
        --enable-languages=c,c++,java,objc \
        --program-suffix=4 \
%ifarch sparc
        --host=%{gcc_target_platform} --build=%{gcc_target_platform} --target=%{gcc_target_platform} --with-cpu=v7
%endif
%ifarch ppc
        --host=%{gcc_target_platform} --build=%{gcc_target_platform} --target=%{gcc_target_platform} --with-cpu=default32
%endif
%ifnarch sparc ppc
        --host=%{gcc_target_platform}
%endif


make %{?_smp_mflags} BOOT_CFLAGS="$OPT_FLAGS" "CC=gcc %{?no_stack_protector}" bootstrap-lean
#make %{?_smp_mflags} BOOT_CFLAGS="$OPT_FLAGS" bootstrap

# run the tests.
make %{?_smp_mflags} -k check || :
make -C %{gcc_target_platform}/libstdc++-v3/testsuite -k check-abi-verbose || :
echo ====================TESTING=========================
( ../contrib/test_summary || : ) 2>&1 | sed -n '/^cat.*EOF/,/^EOF/{/^cat.*EOF/d;/^EOF/d;/^LAST_UPDATED:/d;p;}'
make -C %{gcc_target_platform}/libstdc++-v3/testsuite -k check-abi || :
echo ====================TESTING END=====================
#cd %{gcc_target_platform}/libstdc++-v3
#./mkcheck 0
#cd ../..

# Make protoize
make -C gcc CC="./xgcc -B ./ -O2" proto

# Make c++filt
# make -C %{gcc_target_platform}/libiberty CFLAGS="$RPM_OPT_FLAGS" c++filt

#%ifarch sparc ppc
## Build the -m32 only compiler which does not use long long for HOST_WIDE_INT
#mkdir gcc32
#cd gcc32
#OPT_FLAGS=`echo $RPM_OPT_FLAGS|sed -e 's/-fno-rtti//g' -e 's/-fno-exceptions//g'`
#echo "#!/bin/sh" > gcc32
#echo "exec `cd ../gcc; pwd`/xgcc -B `cd ../gcc; pwd`/ $OPT_FLAGS \$*" >> gcc32
#chmod +x gcc32
#CC=`pwd`/gcc32 CFLAGS="$OPT_FLAGS" CXXFLAGS="$OPT_FLAGS" XCFLAGS="$OPT_FLAGS" \
#  TCFLAGS="$OPT_FLAGS" ../../gcc/configure --prefix=%{_prefix} --mandir=%{_mandir} --infodir=%{_infodir} \
#  --enable-shared --enable-threads=posix --disable-checking \
#  --with-system-zlib --enable-__cxa_atexit \
#  --host=%{_target_platform}
#make %{?_smp_mflags} BOOT_CFLAGS="$OPT_FLAGS" cc1 cc1plus
#cd ..
#%endif

# Make generated man pages even if Pod::Man is not new enough
perl -pi -e 's/head3/head2/' ../contrib/texi2pod.pl
for i in ../gcc/doc/*.texi; do
  cp -a $i $i.orig; sed 's/ftable/table/' $i.orig > $i
done
make -C gcc generated-manpages
for i in ../gcc/doc/*.texi; do mv -f $i.orig $i; done

# Copy various doc files here and there
cd ..
mkdir -p rpm.doc/g77 rpm.doc/objc
mkdir -p rpm.doc/boehm-gc rpm.doc/fastjar rpm.doc/libffi rpm.doc/libjava

(cd gcc/f; for i in ChangeLog*; do
        cp -p $i ../../rpm.doc/g77/$i.f
done)
(cd libf2c; for i in ChangeLog*; do
        cp -p $i ../rpm.doc/g77/$i.libf2c
done)
(cd gcc/objc; for i in README*; do
        cp -p $i ../../rpm.doc/objc/$i.objc
done)
(cd libobjc; for i in README*; do
        cp -p $i ../rpm.doc/objc/$i.libobjc
done)
(cd boehm-gc; for i in ChangeLog*; do
        cp -p $i ../rpm.doc/boehm-gc/$i.gc
done)
(cd fastjar; for i in ChangeLog* README*; do
        cp -p $i ../rpm.doc/fastjar/$i.fastjar
done)
(cd libffi; for i in ChangeLog* README* LICENSE; do
        cp -p $i ../rpm.doc/libffi/$i.libffi
done)
(cd libjava; for i in ChangeLog* README*; do
        cp -p $i ../rpm.doc/libjava/$i.libjava
done)

%install
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf "$RPM_BUILD_ROOT"

perl -pi -e \
  's~href="l(ibstdc|atest)~href="http://gcc.gnu.org/onlinedocs/libstdc++/l\1~' \
  libstdc++-v3/docs/html/documentation.html
ln -sf documentation.html libstdc++-v3/docs/html/index.html
find libstdc++-v3/docs/html -name CVS | xargs rm -rf

cd obj-%{gcc_target_platform}

TARGET_PLATFORM=%{gcc_target_platform}

# There are some MP bugs in libstdc++ and libjava Makefiles
make -C %{gcc_target_platform}/libstdc++-v3

make prefix=$RPM_BUILD_ROOT%{_prefix} mandir=$RPM_BUILD_ROOT%{_mandir} \
  infodir=$RPM_BUILD_ROOT%{_infodir} libexecdir=$RPM_BUILD_ROOT%{_prefix}/lib \
  install

FULLPATH=$RPM_BUILD_ROOT%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}

#cp -a %{gcc_target_platform}/libiberty/c++filt $RPM_BUILD_ROOT%{_prefix}/bin/c++filt
#chmod 755 $RPM_BUILD_ROOT%{_prefix}/bin/c++filt

# fix some things
mkdir -p $RPM_BUILD_ROOT/lib
ln -sf ..%{_prefix}/bin/cpp4 $RPM_BUILD_ROOT/lib/cpp4
rm -f $RPM_BUILD_ROOT%{_infodir}/dir
gzip -9 $RPM_BUILD_ROOT%{_infodir}/*.info*

%ifarch sparc ppc
# Install the sparc/ppc -m32 only compilers
FULLPATH32=$RPM_BUILD_ROOT%{_prefix}/lib/gcc/%{_target_platform}/%{gcc_version}
mkdir -p $FULLPATH32
install -m 755 gcc32/cc1 $FULLPATH32/
install -m 755 gcc32/cc1plus $FULLPATH32/
ln -sf ../../%{gcc_target_platform}/%{gcc_version}/include $FULLPATH32/
ln -f $RPM_BUILD_ROOT%{_prefix}/bin/%{gcc_target_platform}-gcc \
  $RPM_BUILD_ROOT%{_prefix}/bin/%{_target_platform}-gcc
%endif
%ifarch sparc
ln -sf %{gcc_target_platform} \
  $RPM_BUILD_ROOT%{_prefix}/include/c++/%{gcc_version}/%{_target_platform}
%endif
%ifarch ppc
mv $RPM_BUILD_ROOT%{_prefix}/include/c++/%{gcc_version}/%{gcc_target_platform} \
  $RPM_BUILD_ROOT%{_prefix}/include/c++/%{gcc_version}/%{_target_platform}
ln -sf %{_target_platform} \
  $RPM_BUILD_ROOT%{_prefix}/include/c++/%{gcc_version}/%{gcc_target_platform}
%endif
%ifarch sparc64
ln -f $RPM_BUILD_ROOT%{_prefix}/bin/%{gcc_target_platform}-gcc \
  $RPM_BUILD_ROOT%{_prefix}/bin/sparc-%{_vendor}-%{_target_os}-gcc
%endif
%ifarch ppc64
ln -f $RPM_BUILD_ROOT%{_prefix}/bin/%{gcc_target_platform}-gcc \
  $RPM_BUILD_ROOT%{_prefix}/bin/ppc-%{_vendor}-%{_target_os}-gcc
%endif

%ifarch sparc ppc
FULLLPATH=$FULLPATH/lib32
%endif
%ifarch sparc64 ppc64
FULLLPATH=$FULLPATH/lib64
%endif
if [ -n "$FULLLPATH" ]; then
  mkdir -p $FULLLPATH
else
  FULLLPATH=$FULLPATH
fi


mkdir -p $RPM_BUILD_ROOT/%{_lib}
mv -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libgcc_s.so.1 $RPM_BUILD_ROOT/%{_lib}/libgcc_s-%{gcc_version}-%{DATE}.so.1
chmod 755 $RPM_BUILD_ROOT/%{_lib}/libgcc_s-%{gcc_version}-%{DATE}.so.1
ln -sf libgcc_s-%{gcc_version}-%{DATE}.so.1 $RPM_BUILD_ROOT/%{_lib}/libgcc_s.so.1
ln -sf /%{_lib}/libgcc_s.so.1 $FULLPATH/libgcc_s.so
%ifarch sparc ppc
ln -sf /lib64/libgcc_s.so.1 $FULLPATH/libgcc_s_64.so
%endif
%ifarch %{multilib_64_archs}
ln -sf /lib/libgcc_s.so.1 $FULLPATH/libgcc_s_32.so
mv -f $RPM_BUILD_ROOT%{_prefix}/lib/libgcc_s.so.1 $RPM_BUILD_ROOT/lib/
mv -f $RPM_BUILD_ROOT%{_prefix}/lib/libgcc_s_32.so $RPM_BUILD_ROOT/lib/
%endif

pushd $FULLPATH
if [ "%{_lib}" = "lib" ]; then
# ln -sf ../../../libobjc.so.1 libobjc.so
ln -sf ../../../libstdc++.so.6.* libstdc++.so
# ln -sf ../../../libg2c.so.0.* libg2c.so
else
# ln -sf ../../../../%{_lib}/libobjc.so.1 libobjc.so
ln -sf ../../../../%{_lib}/libstdc++.so.6.* libstdc++.so
# ln -sf ../../../../%{_lib}/libg2c.so.0.* libg2c.so
fi
mv -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libstdc++.*a $FULLLPATH/
mv -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libsupc++.*a .
# mv -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libg2c.*a .
# mv -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libfrtbegin.*a .
# mv -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libobjc.*a .

%ifarch sparc ppc
# ln -sf ../../../../../lib64/libobjc.so.1 64/libobjc.so
ln -sf ../`echo ../../../../lib/libstdc++.so.6.* | sed s~/lib/~/lib64/~` 64/libstdc++.so
%endif
%ifarch %{multilib_64_archs}
mkdir -p 32
# ln -sf ../../../../libobjc.so.1 32/libobjc.so
ln -sf ../`echo ../../../../lib64/libstdc++.so.6.* | sed s~/../lib64/~/~` 32/libstdc++.so
# ln -sf ../`echo ../../../../lib64/libg2c.so.0.* | sed s~/../lib64/~/~` 32/libg2c.so
mv -f $RPM_BUILD_ROOT%{_prefix}/lib/libsupc++.*a 32/
# mv -f $RPM_BUILD_ROOT%{_prefix}/lib/libg2c.*a 32/
# mv -f $RPM_BUILD_ROOT%{_prefix}/lib/libfrtbegin.*a 32/
# mv -f $RPM_BUILD_ROOT%{_prefix}/lib/libobjc.*a 32/
%endif
%ifarch sparc64 ppc64
ln -sf ../lib32/libstdc++.a 32/libstdc++.a
ln -sf lib64/libstdc++.a libstdc++.a
%else
%ifarch %{multilib_64_archs}
ln -sf ../../../%{multilib_32_arch}-%{_vendor}-%{_target_os}/%{gcc_version}/libstdc++.a 32/libstdc++.a
%endif
%endif
# Strip debug info from Fortran/ObjC/Java static libraries
strip -g `find . \( -name libg2c.a -o -name libobjc.a -o -name libgcj.a \
                    -o -name lib-org-w3c-dom.a -o -name lib-org-xml-sax.a \
                    -o -name libgcc.a \) -a -type f`
popd
# chmod 755 $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libg2c.so.0.*
# chmod 755 $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libobjc.so.1.*

for h in `find $FULLPATH/include -name \*.h`; do
  if grep -q 'It has been auto-edited by fixincludes from' $h; then
    rh=`grep -A2 'It has been auto-edited by fixincludes from' $h | tail -1 | sed 's|^.*"\(.*\)".*$|\1|'`
    diff -up $rh $h || :
    rm -f $h
  fi
done
cat > $RPM_BUILD_ROOT%{_prefix}/bin/c89 <<"EOF"
#!/bin/sh
fl="-std=c89"
for opt; do
  case "$opt" in
    -ansi|-std=c89|-std=iso9899:1990) fl="";;
    -std=*) echo "`basename $0` called with non ANSI/ISO C option $opt" >&2
            exit 1;;
  esac
done
exec %{_prefix}/bin/gcc $fl ${1+"$@"}
EOF
cat > $RPM_BUILD_ROOT%{_prefix}/bin/c99 <<"EOF"
#!/bin/sh
fl="-std=c99"
for opt; do
  case "$opt" in
    -std=c99|-std=iso9899:1999) fl="";;
    -std=*) echo "`basename $0` called with non ISO C99 option $opt" >&2
            exit 1;;
  esac
done
exec %{_prefix}/bin/gcc $fl ${1+"$@"}
EOF
chmod 755 $RPM_BUILD_ROOT%{_prefix}/bin/c?9

mkdir -p $RPM_BUILD_ROOT%{_prefix}/sbin
gcc -static -Os %{SOURCE3} -o $RPM_BUILD_ROOT%{_prefix}/sbin/libgcc_post_upgrade
strip $RPM_BUILD_ROOT%{_prefix}/sbin/libgcc_post_upgrade

# Cleanup
rm -rf $RPM_BUILD_ROOT%{_prefix}/lib/libffi*
rm -rf $RPM_BUILD_ROOT%{_prefix}/include/ffi.h
rm -rf $RPM_BUILD_ROOT%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/libffi
rm -rf $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libssp*

%clean
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf "$RPM_BUILD_ROOT"

%post
/usr/sbin/htmlinfo_update.sh
/sbin/ldconfig

%postun
/usr/sbin/htmlinfo_update.sh
/sbin/ldconfig

#%post c++-runtime
#/sbin/ldconfig

#%postun c++-runtime
#/sbin/ldconfig

%files
%defattr(-,root,root)
%exclude %{_prefix}/bin/c89
%exclude %{_prefix}/bin/c99
%{_prefix}/bin/gcc4
%{_prefix}/bin/gcov4
%{_prefix}/bin/protoize4
%{_prefix}/bin/unprotoize4
%{_prefix}/bin/gccbug4
%exclude %{_prefix}/bin/i586-trustix-linux-gcc-%{gcc_version}
%ifarch sparc ppc
%{_prefix}/bin/%{_target_platform}-gcc4
%endif
%ifarch sparc64
%{_prefix}/bin/sparc-%{_vendor}-%{_target_os}-gcc4
%endif
%ifarch ppc64
%{_prefix}/bin/ppc-%{_vendor}-%{_target_os}-gcc4
%endif
%{_prefix}/bin/%{gcc_target_platform}-gcc4
%{_mandir}/man1/gcc4.1*
%{_mandir}/man1/gcov4.1*
%exclude %{_infodir}/gcc*
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/stddef.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/stdarg.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/varargs.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/float.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/limits.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/stdbool.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/iso646.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/syslimits.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/unwind.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/mm3dnow.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/mm_malloc.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/jni_md.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/ssp/ssp.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/ssp/stdio.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/ssp/string.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/ssp/unistd.h
%ifarch %{ix86} x86_64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/mmintrin.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/xmmintrin.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/emmintrin.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/pmmintrin.h
%endif
%ifarch ia64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/ia64intrin.h
%endif
%ifarch ppc
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/ppc-asm.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/altivec.h
%endif
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/README
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/collect2
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/crt*.o
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgcc.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgcc_eh.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgcc_s.so
%ifarch sparc ppc
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/crt*.o
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libgcc.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libgcc_eh.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgcc_s_64.so
%endif
%ifarch %{multilib_64_archs}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/crt*.o
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgcc.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgcc_eh.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgcc_s_32.so
%endif
%{_prefix}/lib/gcc/i586-trustix-linux/%{gcc_version}/SYSCALLS.c.X
%exclude %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/install-tools/
%exclude %{_prefix}/lib/libiberty.a
%exclude %{_datadir}/locale/
%exclude %{_mandir}/man7
%doc gcc/README* gcc/*ChangeLog*

%files cpp
%defattr(-,root,root)
/lib/cpp4
%{_prefix}/bin/cpp4
%{_mandir}/man1/cpp4.1*
%exclude %{_infodir}/cpp*
%dir %{_prefix}/lib/gcc
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/cc1
%exclude /%{_lib}/libgcc_s-%{gcc_version}-%{DATE}.so.1
%exclude %{_libdir}/libstdc++.so.6*
%exclude %{_sbindir}/libgcc_post_upgrade

#%files runtime
#%defattr(-,root,root)
#/%{_lib}/libgcc_s-%{gcc_version}-%{DATE}.so.1
#/%{_lib}/libgcc_s.so.1
#%{_prefix}/sbin/libgcc_post_upgrade
#%ifarch %{multilib_64_archs}
#/lib/libgcc_s.so.1
#/lib/libgcc_s_32.so
#%endif

%files c++-devel
%defattr(-,root,root)
%{_prefix}/bin/%{gcc_target_platform}-*++4
%{_prefix}/bin/g++4
%{_prefix}/bin/c++4
#%{_prefix}/bin/c++filt
%{_mandir}/man1/g++4.1*
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/cc1plus
%ifarch sparc ppc
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libstdc++.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libstdc++.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libsupc++.a
%endif
%ifarch %{multilib_64_archs}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libstdc++.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libstdc++.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libsupc++.a
%endif
%ifarch sparc ppc %{multilib_64_archs}
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libstdc++.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libsupc++.a
%endif
%ifarch sparc sparc64 ppc ppc64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libstdc++.a
%endif
%doc gcc/cp/ChangeLog*
%{_prefix}/include/c++
%ifarch sparc ppc
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib32
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib32/libstdc++.a
%endif
%ifarch sparc64 ppc64
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib64/libstdc++.a
%endif
%ifnarch sparc sparc64 ppc ppc64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libstdc++.a
%endif
%ifnarch sparc ppc %{multilib_64_archs}
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libstdc++.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libsupc++.a
%endif
%doc libstdc++-v3/ChangeLog* libstdc++-v3/README* libstdc++-v3/docs/html/
%exclude %{_prefix}/lib/gcc/i586-trustix-linux/%{gcc_version}/libgcov.a
%exclude %{_prefix}/lib/gcc/i586-trustix-linux/%{gcc_version}/libstdc++.la
%exclude %{_prefix}/lib/gcc/i586-trustix-linux/%{gcc_version}/libsupc++.la

#%files c++-runtime
#%defattr(-,root,root)
#%{_prefix}/%{_lib}/libstdc++.so.6.*

%files libmudflap
%defattr(-,root,root)
%{_prefix}/%{_lib}/libmudflap.so.0*
%{_prefix}/%{_lib}/libmudflapth.so.0*
%{_prefix}/%{_lib}/libmudflap*.a
%{_prefix}/%{_lib}/libmudflap*.la

%files libmudflap-devel
%defattr(-,root,root)
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/mm3dnow.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/mm_malloc.h
%{_prefix}/include/mf-runtime.h

%files gcj
%defattr(-,root,root)
%{_prefix}/bin/addr2name.awk4
%{_prefix}/bin/fastjar4
%{_prefix}/bin/gcj-dbtool4
%{_prefix}/bin/gcj4
%{_prefix}/bin/gcjh4
%{_prefix}/bin/gij4
%{_prefix}/bin/gjnih4
%{_prefix}/bin/grepjar4
%{_prefix}/bin/grmic4
%{_prefix}/bin/grmiregistry4
%{_prefix}/bin/i586-trustix-linux-gcj4
%{_prefix}/bin/i586-trustix-linux-gcjh4
%{_prefix}/bin/jcf-dump4
%{_prefix}/bin/jv-convert4
%{_prefix}/bin/jv-scan4
%{_mandir}/man1/fastjar4.1.gz
%{_mandir}/man1/gcj-dbtool4.1.gz
%{_mandir}/man1/gcj4.1.gz
%{_mandir}/man1/gcjh4.1.gz
%{_mandir}/man1/gij4.1.gz
%{_mandir}/man1/gjnih4.1.gz
%{_mandir}/man1/grepjar4.1.gz
%{_mandir}/man1/grmic4.1.gz
%{_mandir}/man1/grmiregistry4.1.gz
%{_mandir}/man1/jcf-dump4.1.gz
%{_mandir}/man1/jv-convert4.1.gz
%{_mandir}/man1/jv-scan4.1.gz
%{_prefix}/lib/security/classpath.security
%{_prefix}/lib/security/libgcj.security
%{_prefix}/lib/logging.properties
%{_prefix}/lib/gcj-%{version}
%{_prefix}/lib/libgcj.so.*
%{_prefix}/lib/libgij.so.*
%{_prefix}/share/info/fastjar.info.gz
%{_prefix}/share/info/gcj.info.gz
%{_prefix}/share/java


%files gcj-devel
%defattr(-,root,root)
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/gcj/libgcj-config.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/jawt.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/jawt_md.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/jni.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/jvmpi.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/jc1
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/jvgenmain
%{_prefix}/lib/pkgconfig/libgcj.pc
%{_prefix}/lib/libgcj.a
%{_prefix}/lib/libgcj.la
%{_prefix}/lib/libgcj.spec
%{_prefix}/lib/libgij.a
%{_prefix}/lib/libgij.la


%files objc
%defattr(-,root,root)
%{_prefix}/lib/libobjc.so.*

%files objc-devel
%defattr(-,root,root)
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/cc1obj
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/objc
%{_prefix}/lib/libobjc.a
%{_prefix}/lib/libobjc.la


%changelog
* Mon Feb 26 2007 Nived Gopalan <nived at trustix dot org> 4.1.1-2tr
- Rebuilt

* Wed Jul 19 2006 Bipin S <bipin at trustix dot org> 4.1.1-1tr
- Initial version for TSL-3.0.5

* Thu Sep 29 2005 Erlend Midttun <erlendbm at trustix dot org> 4.0.2-1tr
- New upstream.

* Tue Aug 30 2005 Erlend Midttun <erlendbm at trustix dot org> 4.0.1-2tr
- Add gcj.  Bug #1237.

* Fri Aug 26 2005 Erlend Midttun <erlendbm at trustix dot org> 4.0.1-1tr
- 4.0.1 official.  Bug #1187.

* Mon May 30 2005 Oystein Viggen <oysteivi at trustix dot com> 4.0.1-0.0.20050423.3tr
- Build with program-suffix=4
- Remove -runtime packages, we use gcc-3.4 provided ones

* Mon May 23 2005 Ajith Thampi <ajith at comodo dot com> 4.0.1-0.0.20050423.2tr
- Added minor fixes as pr21492 and a revised ice-hack		

* Wed Apr 27 2005 Syed Shabir Zakiullah <syedshabir at comodo dot com> 4.0.1-0.0.20050423.1tr
- Taken 4.0-20050423 snapshot of gcc

* Tue Apr 26 2005 Syed Shabir Zakiullah <syedshabir at comodo dot com> 4.0.0-2tr
- Add bug fix patches 

* Fri Apr 22 2005 Syed Shabir Zakiullah <syedshabir at comodo dot com> 4.0.0-1tr
- New Upstream
- Removed stack_protector from GCC-4.0.0 for now
- Added new sub-package libmudflap

* Fri Mar 18 2005 Ajith Thampi <ajith at comodo dot com> 3.4.3-2tr
- Fixed Unpackaged Filelist
- excluded libgcov.a, libstdc++.la,libsupc++.la
- banned the install-tools as we currently have no need of it. 

* Fri Jan  7 2005 Erlend Midttun <erlendbm at trustix dot org> 3.4.3-1tr
- New upstream.

* Tue Aug 24 2004 Oystein Viggen <oysteivi at trustix dot com> 3.4.1-3tr
- Patch version.c to reflect that we ship a patched gcc

* Wed Aug 18 2004 Chr. Toldnes <christht at trustix dot org> 3.4.1-2tr
- cpp package renamed gcc-cpp

* Tue Aug  3 2004 Erlend Midttun <erlendbm at trustix dot org> 3.4.1-1tr
- Official 3.4.1 release.

* Mon Jun 21 2004 Oystein Viggen <oysteivi at trustix dot com> 3.4.0-0.20040612.3tr
- Add ICE patch from GCC bugzilla, bug #16026

* Mon Jun 21 2004 Oystein Viggen <oysteivi at trustix dot com> 3.4.0-0.20040612.1tr
- New upstream: 3.4.0
- Sync with CVS gcc_3_4-branch
- New stack protector upstream: gcc-protector-3.4-2.tar.gz
- c++filt is moved to binutils
- Handle upstream rename of gcc-lib to gcc
- Override upstream move of cc1plus, cc1, and collect2 to libexec

* Mon May  3 2004 Oystein Viggen <oysteivi at trustix dot org> 3.3.3-6tr
- Re-enable IBM's stack protector

* Mon Apr 19 2004 Oystein Viggen <oysteivi at trustix dot org> 3.3.3-5tr
- Import build system from Fedora's gcc 3.3.3-3

* Wed Feb 25 2004 Oystein Viggen <oysteivi at trustix dot org> 3.3.3-1ov
- Port to ppc64

* Wed Feb 18 2004 Omar Kilani <ok at trustix dot org> 3.3.3-1ok
- New upstream.

* Mon Jan 12 2004 Oystein Viggen <oysteivi at trustix dot org> 3.3.2-4ov
- Include IBM's stack protector

* Thu Nov 27 2003 Erlend Midttun <erlendbm at trustix dot com> 3.3.2-3tr
- Fixed more _target_platform stuff.

* Tue Nov 25 2003 Erlend Midttun <erlendbm at trustix dot com> 3.3.2-2tr
- Big rebuild

* Wed Nov 19 2003 Erlend Midttun <erlendbm at trustix dot com> 3.3.2-1tr
- New upstream.

* Mon Jun 23 2003 Erlend Midttun <erlendbm at trustix dot com> 3.3-5tr
- Added %defattr.

* Wed Jun 18 2003 Erlend Midttun <erlendbm at trustix dot com> 3.3-4tr
- Big rebuild

* Thu Jun  5 2003 Erlend Midttun <erlendbm at trustix dot com> 3.3-3em
- No longer own /usr/lib/gcc-lib.

* Thu May 22 2003 Erlend Midttun <erlendbm at trustix dot com> 3.3-2em
- Removed libiberty to avoid conflict.

* Fri May 16 2003 Erlend Midttun <erlendbm at trustix dot com> 3.3-1em
- New upstream -> 3.3
- Now create htmlinfo pages

* Wed May 14 2003 Erlend Midttun <erlendbm at trustix dot com> 3.2.3-2em
- Fixed the ownership of /usr/lib/gcc-lib/i586...

* Thu Apr 24 2003 Erlend Midttun <erlendbm at trustix dot com> 3.2.3-1em
- New upstream.

* Mon Mar 24 2003 Erlend Midttun <erlendbm at trustix dot com> 3.2.2-4em
- Rebuilt against glibc 2.3.2.

* Tue Mar 11 2003 Erlend Midttun <erlendbm at trustix dot com> 3.2.2-3em
- Kick out java, objc and f77 packages.

* Tue Mar 11 2003 Erlend Midttun <erlendbm at trustix dot com> 3.2.2-2em
- Eh?  No changelog

* Wed Feb 19 2003 Erlend Midttun <erlendbm at trustix dot com> 3.2.2-1em
- New version 3.2.2
- Attempt to fix the include file stuff

* Sat Jan 18 2003 Gerald Dachs <gda at trustix dot org> 3.2.1-2gd
- recompiled against openssl 0.9.7-1gd

* Mon Dec  2 2002 Erlend Midttun <erlendbm at trustix dot com> 3.2.1-1em
- New upstream version.

* Wed Nov 20 2002 Erlend Midttun <erlendbm at trustix dot com> 3.2-5em
- Created a gcc-runtime to avoid having a dependency on the full gcc package.

* Fri Sep 13 2002 Erlend Midttun <erlendbm at trustix dot com> 3.2-4em
- Added /lib/cpp
- Trying to use only --enable-threads

* Fri Sep  6 2002 Erlend Midttun <erlendbm at trustix dot com> 3.2-3em
- Fix libgcc.so
- Fixed %dir on the compiler dir
- Added default attributes.
- Remove info files for now.
- Added .so's to file lists.

* Fri Aug 23 2002 Erlend Midttun <erlendbm at trustix dot com> 3.2-2em
- Added Provides gcc-c++
- Fixed files section of c++

* Wed Aug 21 2002 Erlend Midttun <erlendbm at trustix dot com> 3.2-1em
- Take 3.2

* Wed Jul 24 2002 Christian H. Toldnes <christht at trustix dot com> 3.1-2ct
- Added ada, fortran, objective c, and java support

* Wed Jul 24 2002 Christian H. Toldnes <christht at trustix dot com> 3.1-1ct
- initial release of version 3.1 for TSL
- Only one really big package for now, to ensure all files gets included.

* Tue Feb 26 2002 Erlend Midttun <erlendbm at trustix dot com>
- Added atexit patch.

* Mon Mar 26 2001 Oystein Viggen <oysteivi at trustix dot com>
- Upgrade to v2.95.3
- Handle gzipped man files

* Wed Mar 29 2000 Lars Gaarden <larsg at trustix dot com>
- Moved man and info pages to /usr/share, FHS.

* Sat Dec 11 1999 Bernhard Rosenkraenzer <bero@redhat.com>
- Obsolete egcs*, g77
- Add egcs 1.1.x'ish libstdc++ versions to libstdc++-compat

* Wed Dec  8 1999 Bernhard Rosenkraenzer <bero@redhat.com>
- Fix build on sparc

* Tue Dec  7 1999 Bernhard Rosenkraenzer <bero@redhat.com>
- Add -warn patch (adapted from egcs-1.1.2 RPM)
- drop release number to 1 for 7.0 tree

* Tue Oct 26 1999 Bernhard Rosenkraenzer <bero@redhat.com>
- 2.95.2 release

* Sun Oct 24 1999 Bernhard Rosenkraenzer <bero@redhat.com>
- initial RPM

